// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#include <fennec/containers/dynarray.h>
#include <fennec/containers/set.h>
#include <fennec/core/event.h>

namespace fennec
{

static dynarray<set<event_listener*>> listeners;

void event::add_listener(event_listener* listener, uint64_t type) {
	if (listeners.size() <= type) {
		listeners.resize(type + 1);
	}
	listeners[type].insert(listener);
}

void event::remove_listener(event_listener* listener) {
	for (auto& it : listeners) {
		it.erase(listener);
	}
}

void event::dispatch(event* event) {
	for (auto& it : listeners[event->type]) {
		it->handle_event(event);
	}
}

}
